diff --git a/src/pbkdf2-hmac-sha512_fmt_plug.c b/src/pbkdf2-hmac-sha512_fmt_plug.c
index 9a64742a4c..289e6e8268 100644
--- a/src/pbkdf2-hmac-sha512_fmt_plug.c
+++ b/src/pbkdf2-hmac-sha512_fmt_plug.c
@@ -148,6 +148,9 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	if (!ishex(ptr))
 		goto error;
+	ptr = strtok(NULL, ".");
+	if (ptr)
+		goto error;
 	MEM_FREE(keeptr);
 	return 1;
 error:
